diff --git a/src/backend/catalog/pg_db_role_setting.c b/src/backend/catalog/pg_db_role_setting.c
index cafb182e0d5..53cab1f3701 100644
--- a/src/backend/catalog/pg_db_role_setting.c
+++ b/src/backend/catalog/pg_db_role_setting.c
@@ -240,6 +240,8 @@ AlterSetting(Oid databaseid, Oid roleid, VariableSetStmt *setstmt)
 			appendStringInfo(&buffer, "RESET ALL");
 		else if (valuestr == NULL)
 			appendStringInfo(&buffer, "RESET %s", quote_identifier(setstmt->name));
+		else if (setstmt->kind ==  VAR_SET_CURRENT)
+			appendStringInfo(&buffer, "SET %s TO %s", quote_identifier(setstmt->name), quote_identifier(valuestr));
 		else
 		{
 			ListCell   *l;
diff --git a/src/test/regress/input/dispatch.source b/src/test/regress/input/dispatch.source
index 7c1a68a90d4..93093d6fb92 100644
--- a/src/test/regress/input/dispatch.source
+++ b/src/test/regress/input/dispatch.source
@@ -115,6 +115,17 @@ DROP TABLE public."my table";
 CREATE TABLE "my table" (id integer);
 DROP TABLE "my table";
 
+-- test ALTER DATABASE SET FROM CURRENT
+SHOW search_path;
+ALTER DATABASE "dispatch test db" RESET ALL;
+\c
+SHOW search_path;
+SET search_path="my schema", public;
+SHOW search_path;
+ALTER DATABASE "dispatch test db" SET search_path FROM CURRENT;
+\c
+SHOW search_path;
+
 -- Clean up
 \c dispatch_test_db
 DROP DATABASE "dispatch test db";
diff --git a/src/test/regress/output/dispatch.source b/src/test/regress/output/dispatch.source
index 9350ff76cf6..cfa9fe5b593 100644
--- a/src/test/regress/output/dispatch.source
+++ b/src/test/regress/output/dispatch.source
@@ -156,6 +156,36 @@ CREATE TABLE "my table" (id integer);
 NOTICE:  Table doesn't have 'DISTRIBUTED BY' clause -- Using column named 'id' as the Greenplum Database data distribution key for this table.
 HINT:  The 'DISTRIBUTED BY' clause determines the distribution of data. Make sure column(s) chosen are the optimal data distribution key to minimize skew.
 DROP TABLE "my table";
+-- test ALTER DATABASE SET FROM CURRENT
+SHOW search_path;
+     search_path     
+---------------------
+ "my schema", public
+(1 row)
+
+ALTER DATABASE "dispatch test db" RESET ALL;
+\c
+SHOW search_path;
+   search_path   
+-----------------
+ "$user", public
+(1 row)
+
+SET search_path="my schema", public;
+SHOW search_path;
+     search_path     
+---------------------
+ "my schema", public
+(1 row)
+
+ALTER DATABASE "dispatch test db" SET search_path FROM CURRENT;
+\c
+SHOW search_path;
+     search_path     
+---------------------
+ "my schema", public
+(1 row)
+
 -- Clean up
 \c dispatch_test_db
 DROP DATABASE "dispatch test db";
